## ros-kinetic-robot-controllers 0.5.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(robot_controllers)

if (CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Werror -Wno-unused-parameter")
endif()

find_package(orocos_kdl REQUIRED)
find_package(Boost REQUIRED python system)
find_package(PythonLibs REQUIRED)
find_package(catkin REQUIRED
  COMPONENTS
    actionlib
    actionlib_msgs
    angles
    control_msgs
    geometry_msgs
    kdl_parser
    nav_msgs
    pluginlib
    robot_controllers_interface
    roscpp
    sensor_msgs
    tf
    tf_conversions
    trajectory_msgs
    urdf
)

catkin_python_setup()

catkin_package(
  INCLUDE_DIRS
    include
  CATKIN_DEPENDS
    actionlib
    actionlib_msgs
    control_msgs
    geometry_msgs
    kdl_parser
    nav_msgs
    pluginlib
    robot_controllers_interface
    roscpp
    sensor_msgs
    tf
    tf_conversions
    trajectory_msgs
    urdf
  DEPENDS
    Boost
    orocos_kdl
    Python
  LIBRARIES
    robot_controllers
)

include_directories(
  include
  ${Boost_INCLUDE_DIRS}
  ${catkin_INCLUDE_DIRS}
  ${orocos_kdl_INCLUDE_DIRS}
  ${PYTHON_INCLUDE_PATH}
)

# this is a hack, will eventually be unneeded once orocos-kdl is fixed
link_directories(${orocos_kdl_LIBRARY_DIRS})

add_library(robot_controllers
  src/cartesian_pose.cpp
  src/cartesian_twist.cpp
  src/cartesian_wrench.cpp
  src/diff_drive_base.cpp
  src/diff_drive_limiter.cpp
  src/follow_joint_trajectory.cpp
  src/gravity_compensation.cpp
  src/parallel_gripper.cpp
  src/pid.cpp
  src/point_head.cpp
  src/scaled_mimic.cpp
)
target_link_libraries(robot_controllers
  ${catkin_LIBRARIES}
  ${orocos_kdl_LIBRARIES}
)

add_library(robot_controllers_python
  src/robot_controllers_python.cpp
)
target_link_libraries(robot_controllers_python
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
  ${PYTHON_LIBRARIES}
  robot_controllers
)
set_target_properties(robot_controllers_python
  PROPERTIES
  LIBRARY_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_GLOBAL_PYTHON_DESTINATION}/robot_controllers/
  PREFIX ""
)
if(APPLE)
  set_target_properties(robot_controllers_python PROPERTIES SUFFIX ".so")
endif()


if (CATKIN_ENABLE_TESTING)
  add_subdirectory(test)
endif()

install(DIRECTORY include/ DESTINATION include)

install(FILES robot_controllers.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

install(
  TARGETS robot_controllers
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)

install(
  TARGETS robot_controllers_python
  LIBRARY DESTINATION ${CATKIN_GLOBAL_PYTHON_DESTINATION}
)

=== test/CMakeLists.txt ===
catkin_add_gtest(trajectory_tests trajectory_tests.cpp)
target_link_libraries(trajectory_tests
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
)

catkin_add_gtest(diff_drive_limiter_test diff_drive_limiter_test.cpp)
target_link_libraries(diff_drive_limiter_test robot_controllers)

=== debian/changelog ===
ros-kinetic-robot-controllers (0.5.2-0xenial) xenial; urgency=high

  * do not export python library for linking
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Mon, 18 Jul 2016 07:00:00 -0000

ros-kinetic-robot-controllers (0.5.1-0xenial) xenial; urgency=high

  * base_controller: only update odometry if inputs are finite (prevents NANs to TF)
  * base_controller: add velocity limiting
  * pid: fix error in derivative error calculation
  * allow velocity limiting code be reused for forward simulation #18 <https://github.com/fetchrobotics/robot_controllers/issues/18>
  * Contributors: Cappy Pitts, Derek King, Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Mon, 18 Jul 2016 07:00:00 -0000

ros-kinetic-robot-controllers (0.5.0-0xenial) xenial; urgency=high

  * require finite commands to base controller
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Sun, 21 Feb 2016 08:00:00 -0000

ros-kinetic-robot-controllers (0.4.3-0xenial) xenial; urgency=high

  * fix path/goal tolerance preparation
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Sat, 05 Dec 2015 08:00:00 -0000

ros-kinetic-robot-controllers (0.4.2-0xenial) xenial; urgency=high

  * fixed segmentation faults due to misconfiguration
  * Contributors: Arvin Asokan

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Thu, 22 Oct 2015 07:00:00 -0000

ros-kinetic-robot-controllers (0.4.1-0xenial) xenial; urgency=high

  * add centering pid to gripper controller
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Fri, 12 Jun 2015 07:00:00 -0000

ros-kinetic-robot-controllers (0.4.0-0xenial) xenial; urgency=high



 -- Michael Ferguson <mferguson@fetchrobotics.com>  Sat, 23 May 2015 07:00:00 -0000

ros-kinetic-robot-controllers (0.3.4-0xenial) xenial; urgency=high

  * add ability to reset controllers
  * add timeout to laser speed scaling
  * maintain constant curvature when scaling base velocity
  * remove DiffDriveBaseController::publish()
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Fri, 22 May 2015 07:00:00 -0000

ros-kinetic-robot-controllers (0.3.3-0xenial) xenial; urgency=high

  * use laser to slow base when obstacles are near
  * add mutexes around command/odometry. publish odom in timer
  * add -Wall to compile flags, fix compile warnings
  * Contributors: Derek King, Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Sun, 03 May 2015 07:00:00 -0000

ros-kinetic-robot-controllers (0.3.2-0xenial) xenial; urgency=high



 -- Michael Ferguson <mferguson@fetchrobotics.com>  Thu, 09 Apr 2015 07:00:00 -0000

ros-kinetic-robot-controllers (0.3.1-0xenial) xenial; urgency=high

  * use shortest_angular_distance for diff drive dx calculations
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Sat, 28 Mar 2015 07:00:00 -0000

ros-kinetic-robot-controllers (0.3.0-0xenial) xenial; urgency=high

  * improve windup support
  * make spliced trajectory consistent in qd/qdd size
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Mon, 23 Mar 2015 07:00:00 -0000

ros-kinetic-robot-controllers (0.1.4-0xenial) xenial; urgency=high

  * follow joint trajectory: add stop_on_path_violation parameter
  * diff drive controller: split theta update into two parts
  * diff drive controller: fix frames in odometry message
  * diff drive controller: add autostart
  * scaled mimic controller: add autostart
  * add root/tip params to gravity compensation
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Fri, 13 Mar 2015 07:00:00 -0000

ros-kinetic-robot-controllers (0.1.3-0xenial) xenial; urgency=high

  * add scaled mimic controller (for bellows)
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Wed, 28 Jan 2015 08:00:00 -0000

ros-kinetic-robot-controllers (0.1.2-0xenial) xenial; urgency=high



 -- Michael Ferguson <mferguson@fetchrobotics.com>  Tue, 06 Jan 2015 08:00:00 -0000

ros-kinetic-robot-controllers (0.1.1-0xenial) xenial; urgency=high

  * initial release
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Mon, 05 Jan 2015 08:00:00 -0000

=== debian/control ===
Source: ros-kinetic-robot-controllers
Section: misc
Priority: extra
Maintainer: Michael Ferguson <mferguson@fetchrobotics.com>
Build-Depends: debhelper (>= 9.0.0), ros-kinetic-actionlib, ros-kinetic-actionlib-msgs, ros-kinetic-angles, ros-kinetic-catkin, ros-kinetic-control-msgs, ros-kinetic-geometry-msgs, ros-kinetic-kdl-parser, ros-kinetic-nav-msgs, ros-kinetic-orocos-kdl, ros-kinetic-pluginlib, ros-kinetic-robot-controllers-interface, ros-kinetic-roscpp, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-tf, ros-kinetic-tf-conversions, ros-kinetic-trajectory-msgs, ros-kinetic-urdf
Homepage: 
Standards-Version: 3.9.2

Package: ros-kinetic-robot-controllers
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-actionlib, ros-kinetic-actionlib-msgs, ros-kinetic-control-msgs, ros-kinetic-geometry-msgs, ros-kinetic-kdl-parser, ros-kinetic-nav-msgs, ros-kinetic-orocos-kdl, ros-kinetic-pluginlib, ros-kinetic-robot-controllers-interface, ros-kinetic-roscpp, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-tf, ros-kinetic-tf-conversions, ros-kinetic-trajectory-msgs, ros-kinetic-urdf
Description: Some basic robot controllers for use with robot_controllers_interface.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-robot-controllers//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
